"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactTransitionGroup = require("react-transition-group");
var _propTypes = require("prop-types");
var _container = _interopRequireWildcard(require("./container"));
var _alertTimer = _interopRequireWildcard(require("./alert-timer"));
var _alertTransition = _interopRequireDefault(require("./alert-transition"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const AlertList = ({
  position,
  alerts,
  onDismiss,
  ...props
}) => {
  const classes = (0, _container.useStyles)();
  return /*#__PURE__*/_react.default.createElement(_container.default, {
    position: position,
    className: classes.container
  }, /*#__PURE__*/_react.default.createElement(_reactTransitionGroup.TransitionGroup, null, alerts.map(item => {
    const dismiss = onDismiss ? () => onDismiss(item) : null;
    const {
      message,
      ...alertProps
    } = item;
    return /*#__PURE__*/_react.default.createElement(_alertTransition.default, {
      key: item.id
    }, /*#__PURE__*/_react.default.createElement(_alertTimer.default, _extends({}, props, alertProps, {
      onDismiss: dismiss
    }), message));
  })));
};
const {
  timeout,
  type,
  headline
} = _alertTimer.PropTypes;
AlertList.propTypes = {
  ..._container.PropTypes,
  alerts: (0, _propTypes.arrayOf)((0, _propTypes.shape)({
    id: _propTypes.any.isRequired,
    type,
    headline,
    message: (0, _propTypes.oneOfType)([_propTypes.string, _propTypes.node, _propTypes.object]).isRequired
  })).isRequired,
  onDismiss: _propTypes.func,
  timeout
};
var _default = AlertList;
exports.default = _default;